
DIRECTORY_S struct  
FileName        DB      8 dup (?)
ByteCheckSum    DB      ?
ControleBits    DB      ?
ProgramSize     DW      ?
LocationL       DW      ?
LocationH       DW      ?
DIRECTORY_S ENDS

IPLW_START_ADDR         equ     70000100h  ; Sub IPLwareuƂ
IPLW_START_ADDR2        equ     700000FCh  ; Sub IPLwareuƂ
IPLW_SEGMENT            equ     7000h      ; ̃ZOgƈv
;INSTRUCTIONS_FOR_TYPE2  equ    0CB0001E8h  ; [FC] CALL 100, RETF ߃R[h
INSTRUCTIONS_TYPE2_L    equ     01E8h  ; [FC] CALL 100, RETF ߃R[h
INSTRUCTIONS_TYPE2_H    equ    0CB00h  ; [FC] CALL 100, RETF ߃R[h
ROW_num                 equ     22
COLUMN_num              equ     54
.8086
;---------------------------------------------------------------------
;        unildr  1.20  Copyright(C) 2022 DOSsoft  ( 2019.6.4 | 22.10.10 )
;---------------------------------------------------------------------
code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:          
                jmp     ProgramStart    ; TABLEf[^ɃWv
                DB        "IPLware"
.8086           

align 16

CodeBase        EQU (offset ApplicationPointer - offset start)


DirectoryList16        label   byte
;                                 cs   fl  sz ofsL ofsH
dir00     DIRECTORY_S <"IPLApp00",00h, 00h, 2,CodeBase    ,0000h>
dir01     DIRECTORY_S <"IPLApp 1",00h, 40h, 1,CodeBase+02h,0000h>
dir02     DIRECTORY_S <"IPLApp02",00h, 00h, 1,CodeBase+03h,0000h>
dir03     DIRECTORY_S <"IPLApp 3",00h, 40h, 1,CodeBase+04h,0000h>
dir04     DIRECTORY_S <"IPLApp04",00h, 10h, 1,CodeBase+05h,0000h>
dir05     DIRECTORY_S <"IPLApp 5",00h, 50h, 1,CodeBase+06h,0000h>
dir06     DIRECTORY_S <"IPLApp06",00h, 50h, 1,CodeBase+07h,0000h>
dir07     DIRECTORY_S <"IPLApp07",00h, 50h, 1,CodeBase+08h,0000h>
dir08     DIRECTORY_S <"IPLApp08",00h, 50h, 1,CodeBase+09h,0000h>
dir09     DIRECTORY_S <"IPLApp09",00h, 50h, 1,CodeBase+0Ah,0000h>
dir10     DIRECTORY_S <"IPLApp10",00h, 50h, 1,CodeBase+0Bh,0000h>
dir11     DIRECTORY_S <"IPLApp11",00h, 40h, 1,CodeBase+0Ch,0000h>
dir12     DIRECTORY_S <"IPLApp12",00h, 40h, 1,CodeBase+0Dh,0000h>
dir13     DIRECTORY_S <"IPLApp13",00h, 40h, 1,CodeBase+0Eh,0000h>
dir14     DIRECTORY_S <"IPLApp14",00h, 00h, 2,CodeBase+0Fh,0000h>
dir15     DB      16 dup (0)

ProgramStart:                   
                push    ax
                push    bx
                push    cx
                push    dx
                push    si
                push    di
                push    bp
                push    ds
                push    es
                
                xor     ax,ax
                mov     es,ax
                test    byte ptr es:[501h],8    ; nC]`FbN
                jz      @f
                mov     TVRAM_SEG,0E000h        ; nC]VRAMZOg
        @@:     
                mov     ListPosition, ax
                mov     si,offset DirectoryList16

FindDirectory:  
                mov     ax,[si]         ; iplwarẽt@C擪
                mov     bx,[si+2]       ; QoCg
                or      ax,bx           ; 炪OH
                jz      EndExec         ; ~
                cmp     ax,2020h        ; 擪Xy[XH
                jz      EndExec         ; ~

                mov     es,TVRAM_SEG    ; ES=A000/E000
                mov     cx,8
                mov     di,(ROW_num*80+COLUMN_num)*2    ; VRAM\ʒu
                mov     bx,si
        @@:     mov     al,[bx]
                inc     bx
                mov     ah,0
                stosw
               loop     @b

                call    LoadProgram     ; ES=IPLwarẽZOg
                jc      EndExec
                mov     dx,0FFFFh       ; dx:cx fBXNR/Wꍇ̈S[u
                mov     cx,dx
                mov     di,cx   ; 3.3ȏ̃o[WT|[g(!=0)

;               mov     al,[si].ControleBits
                mov     WaitLoopTime,1
                test    al,00010000b    ; bit 5, wait flag
                jz      @f
                mov     WaitLoopTime,0FFF0h  
        @@:     
                mov     bp,IPLW_SEGMENT
                
                push    ds
                mov     ds:SP_save,sp
                mov     ds:SS_save,ss
                mov     si,0300h        ; TuIPLwatẽo[W3.00
                cli
                mov     sp,0FFF0h       ; X^bÑTCY͖64KB
                mov     ss,bp   ; 7000h
                mov     es,bp   ; 7000h
                mov     ds,bp   ; ss,ds,es ͂̎_IPLwaresegment
                sti

                test    al,01000000b    ; bit 6, com file type flag
                jz      Module_type1
Module_type2:   ;;;; mov     EBP,INSTRUCTIONS_FOR_TYPE2
                mov     ax,INSTRUCTIONS_TYPE2_L ; 2022-5-23 fixed to use 16bit code
                mov     word ptr es:[00FCh],ax
                mov     ax,INSTRUCTIONS_TYPE2_H
                mov     word ptr es:[00FEh],ax
;;;;;;;;;;;;;;; call far IPLW_SEGMENT:00FC
                DB      9Ah ; ( call far l )
IPLW2EntryPoint DD      IPLW_START_ADDR2
                jmp     UserProgramTerminated
Module_type1: 
;;;;;;;;;;;;;;; call far IPLW_SEGMENT:0100h
                DB      9Ah ; ( call far l )
IPLW1EntryPoint DD      IPLW_START_ADDR
UserProgramTerminated:
                cli
                mov     sp,cs:SP_save   ; stack pointer 𕜋A
                mov     ss,cs:SS_save
                sti
                pop     ds              ; ̏ʂ ES != DS

                call    shiftkey_check  ; \ێ

EndExec:        inc     ListPosition    ; list position
                mov     si,ListPosition
                shl     si,1  ;  Xgʒu16{čs擪ʒu𓾂
                shl     si,1
                shl     si,1
                shl     si,1
                add     si,offset DirectoryList16; Xg̐擪̈ʒu
                cmp     ListPosition,16
                jb      FindDirectory

                pop     es
                pop     ds
                pop     bp
                pop     di
                pop     si
                pop     dx
                pop     cx
                pop     bx
                pop     ax
                retF
;                ret
;-----------------------------------------------------
;    LoadProgram        return:  AL=ctrlbit  
;-----------------------------------------------------
LoadProgram     PROC   near
                mov     ax,[si].LocationH
                or      ax,ax
                jnz     LoadProgramERR
                mov     ax,IPLW_SEGMENT
                mov     es,ax
                mov     al,[si].ControleBits
                mov     bx,[si].LocationL
                mov     cx,[si].ProgramSize
                or      cx,cx           ; 2019-6-4 added
                jz      LoadProgramERR    ; 2019-6-4 added

                push    si
                mov     si,bx
                mov     di,0100h        ; COM file's ORIGIN =100h
                add     si,di
      rep       movsb
                pop     si

                clc
                ret
LoadProgramERR: stc
                ret
LoadProgram     ENDP

;------------------------------------------------------------------
;         shiftkey_check  VtgL[`FbN҂ I
;------------------------------------------------------------------
SHIFT_KEY       equ     1
shiftkey_check  PROC    near
                mov     cx,WaitLoopTime
WaitEnt:        out     5fh,al
                out     5fh,al
                out     5fh,al
                out     5fh,al
                out     5fh,al
                out     5fh,al
                out     5fh,al
               loop     WaitEnt
        @@:     mov     ah,02h
                int 18h
                test    al,SHIFT_KEY
                jnz     @b
                ret
shiftkey_check  ENDP

;-----------------------------------------------------
WaitLoopTime    DW      0010h
TVRAM_SEG       DW      0A000h
SP_save         DW      0
SS_save         DW      0
ListPosition    DW      0
;-----------------------------------------------------
;dmy     DB 0
;-----------------------------------------------------
align 16
ApplicationPointer        label   byte
DB      090h
DB      0CBh
DB      0C3h
DB      0CBh
DB      0C3h
DB      0CBh
DB      0C3h
DB      0C3h
DB      0C3h
DB      0C3h
DB      0C3h
DB      0C3h
DB      0C3h
DB      0C3h
DB      0C3h
DB      0CBh

code    ends
        end     start


